//+------------------------------------------------------------------+
//|                                                    periodgen.mq4 |
//|                                                     Igor Morozov |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Igor Morozov"
#property link      ""

#include <stdlib.mqh>

#define DATA_FOLDER "databank"
#define BS "\\"

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
	// initialize
	int i;
	int iFile,lFile,pFile[6];
	string iFileName="M1_"+Symbol()+".hst";
	string lFileName=Symbol()+BS+Symbol()+".log";
	int pTime[6];
	double pOpen[6];
	double pLow[6];
	double pHigh[6];
	double pClose[6];
	double pVolume[6];
	int pPeriod[6];
	int pCount[6];
	pPeriod[0]=PERIOD_M5;
	pPeriod[1]=PERIOD_M15;
	pPeriod[2]=PERIOD_M30;
	pPeriod[3]=PERIOD_H1;
	pPeriod[4]=PERIOD_H4;
	pPeriod[5]=PERIOD_D1;
	string pFileName[6];
	pFileName[0]=Symbol()+BS+Symbol()+PERIOD_M5+".hst";
	pFileName[1]=Symbol()+BS+Symbol()+PERIOD_M15+".hst";
	pFileName[2]=Symbol()+BS+Symbol()+PERIOD_M30+".hst";
	pFileName[3]=Symbol()+BS+Symbol()+PERIOD_H1+".hst";
	pFileName[4]=Symbol()+BS+Symbol()+PERIOD_H4+".hst";
	pFileName[5]=Symbol()+BS+Symbol()+PERIOD_D1+".hst";
   int f_Unused[13];
   // open files
	iFile=FileOpen(DATA_FOLDER+BS+iFileName,FILE_BIN|FILE_READ);
	if(iFile<0)
	{
		Print(iFileName," Open Error: ",ErrorDescription(GetLastError()));
		return(0);
	}
	lFile=FileOpen(DATA_FOLDER+BS+lFileName,FILE_CSV|FILE_WRITE," ");
	if(lFile<0)
	{
		Print(lFileName," Open Error: ",ErrorDescription(GetLastError()));
		return(0);
	}
	if(FileSize(iFile)<192)
	{
		Print(iFileName," has no data");
		return(0);
	}
	for(i=0;i<6;i++)
	{
		pFile[i]=FileOpen(DATA_FOLDER+BS+pFileName[i],FILE_BIN|FILE_WRITE);
		if(pFile[i]<0)
		{
			Print(pFileName[i]," Open Error: ",ErrorDescription(GetLastError()));
			return(0);
		}
	}
	FileWrite(lFile,"Creating all timeframes for",Symbol(),
				"from",DATA_FOLDER+BS+iFileName);
	// read header
	int f_Version=FileReadInteger(iFile);
	string f_CopyRight=FileReadString(iFile,64);
	string f_Symbol=FileReadString(iFile,12);
	int f_Period=FileReadInteger(iFile);
	int f_Digits=FileReadInteger(iFile);
	int f_TimeStamp=FileReadInteger(iFile);
	int f_Sync=FileReadInteger(iFile);
	FileReadArray(iFile,f_Unused,0,13);
	FileWrite(lFile,"*------------------------------------------------");
	FileWrite(lFile,"Header Information copied:");
	FileWrite(lFile,"   Version:","\t",f_Version);
	FileWrite(lFile," CopyRight:","\t",f_CopyRight);
	FileWrite(lFile,"    Symbol:","\t",f_Symbol);
	FileWrite(lFile,"    Period:","\t",f_Period);
	FileWrite(lFile,"    Digits:","\t",f_Digits);
	FileWrite(lFile,"Time Stamp:","\t",TimeToStr(f_TimeStamp));
	FileWrite(lFile,"      Sync:","\t",f_Sync);
	FileWrite(lFile,"*------------------------------------------------");
	// write output headers
	for(i=0;i<6;i++)
	{
	   FileWriteInteger(pFile[i],f_Version,LONG_VALUE);
   	FileWriteString(pFile[i],f_CopyRight,64);
   	FileWriteString(pFile[i],f_Symbol,12);
   	FileWriteInteger(pFile[i],pPeriod[i],LONG_VALUE);
   	FileWriteInteger(pFile[i],f_Digits,LONG_VALUE);
   	FileWriteInteger(pFile[i],TimeCurrent(),LONG_VALUE);       //timesign
   	FileWriteInteger(pFile[i],f_Sync,LONG_VALUE);       //last_sync
   	FileWriteArray(pFile[i],f_Unused,0,13);
	}
	// init timeframes
	int iCount;
	int tCount=(FileSize(iFile)-148)/44;
   int f_Time=FileReadInteger(iFile);
   double f_Open=FileReadDouble(iFile);
   double f_Low=FileReadDouble(iFile);
   double f_High=FileReadDouble(iFile);
   double f_Close=FileReadDouble(iFile);
   double f_Volume=FileReadDouble(iFile);
   iCount++;
	FileWrite(lFile,"Start Time: ",TimeToStr(f_Time));
   for(i=0;i<6;i++)
   {
   	pTime[i]=f_Time-f_Time%(pPeriod[i]*60);
   	pOpen[i]=f_Open;
   	pLow[i]=f_Low;
   	pHigh[i]=f_High;
   	pClose[i]=f_Close;
   	pVolume[i]=f_Volume;
   }
	// creation loop	
//	int testcount;
	while(true)
	{
		bool isEndOfFile=FileTell(iFile)>=FileSize(iFile)-1;
		if(!isEndOfFile)
		{
	   	f_Time=FileReadInteger(iFile);
	   	f_Open=FileReadDouble(iFile);
   		f_Low=FileReadDouble(iFile);
   		f_High=FileReadDouble(iFile);
	   	f_Close=FileReadDouble(iFile);
   		f_Volume=FileReadDouble(iFile);
   		iCount++;
	   	if(iCount%10000==0)
   			Print(DoubleToStr(iCount*100.0/tCount,0),"% processed");
   	}
//   	testcount++;
   	for(i=0;i<6;i++)
   	{
   		int newtime=f_Time-f_Time%(pPeriod[i]*60);
//   		if(newtime!=pTime[i]||FileIsEnding(iFile)||testcount>500)
   		if(newtime!=pTime[i]||isEndOfFile)
   		{
	         FileWriteInteger(pFile[i],pTime[i]);
   	      FileWriteDouble(pFile[i],pOpen[i]);
      	   FileWriteDouble(pFile[i],pLow[i]);
         	FileWriteDouble(pFile[i],pHigh[i]);
	         FileWriteDouble(pFile[i],pClose[i]);
   	      FileWriteDouble(pFile[i], pVolume[i]);
   	      pCount[i]++;
   	      if(pCount[i]%5000==0)
   	      	FileFlush(pFile[i]);
   	      if(!isEndOfFile)
   	      {
		   		pTime[i]=newtime;
   				pOpen[i]=f_Open;
		   		pLow[i]=f_Low;
   				pHigh[i]=f_High;
		   		pClose[i]=f_Close;
   				pVolume[i]=f_Volume;
   			}
   		}
   		else
   		{
   			pClose[i]=f_Close;
   			if(pLow[i]>f_Low)
   				pLow[i]=f_Low;
   			if(pHigh[i]<f_High)
   				pHigh[i]=f_High;
   			pVolume[i]+=f_Volume;
   		}
   	}
   	if(isEndOfFile)
   		break;
//   	if(testcount>500)
//   		break;
	}
	// finish up
	FileWrite(lFile,"  End Time: ",TimeToStr(f_Time));
	FileWrite(lFile,"*------------------------------------------------");
	FileWrite(lFile,"Records Processed ("+Symbol()+"1): ",iCount);
	FileWrite(lFile,"Records Created:");
	for(i=0;i<6;i++)
		FileWrite(lFile,Symbol()+pPeriod[i]+":",pCount[i]);
   FileClose(iFile);
   FileClose(lFile);
   for(i=0;i<6;i++)
   	FileClose(pFile[i]);
	// test display
/*	FileWrite(lFile,"*------------------------------------------------");
		iFile=FileOpen(DATA_FOLDER+BS+iFileName,FILE_BIN|FILE_READ);
		if(iFile<0)
		{
			Print(iFileName," Open Error: ",ErrorDescription(GetLastError()));
			return(0);
		}
		FileSeek(iFile,148,SEEK_SET);
		FileWrite(lFile,"Test Results for",Symbol()+"1");
		while(!FileIsEnding(iFile))
		{
		   f_Time=FileReadInteger(iFile);
   		f_Open=FileReadDouble(iFile);
   		f_Low=FileReadDouble(iFile);
   		f_High=FileReadDouble(iFile);
   		f_Close=FileReadDouble(iFile);
   		f_Volume=FileReadDouble(iFile);
   		FileWrite(lFile,TimeToStr(f_Time),
   				DoubleToStr(f_Open,4),DoubleToStr(f_Low,4),
   				DoubleToStr(f_High,4),DoubleToStr(f_Close,4),
   				DoubleToStr(f_Volume,0));
		}
	for(i=0;i<6;i++)
	{
		pFile[i]=FileOpen(DATA_FOLDER+BS+pFileName[i],FILE_BIN|FILE_READ);
		if(pFile[i]<0)
		{
			Print(pFileName[i]," Open Error: ",ErrorDescription(GetLastError()));
			return(0);
		}
		FileSeek(pFile[i],-44,SEEK_END);
		FileWrite(lFile,"Test Results for",Symbol()+pPeriod[i]);
		while(!FileIsEnding(pFile[i]))
		{
		   f_Time=FileReadInteger(pFile[i]);
		   if(GetLastError()!=0)
		   	break;
   		f_Open=FileReadDouble(pFile[i]);
   		f_Low=FileReadDouble(pFile[i]);
   		f_High=FileReadDouble(pFile[i]);
   		f_Close=FileReadDouble(pFile[i]);
   		f_Volume=FileReadDouble(pFile[i]);
   		FileWrite(lFile,TimeToStr(f_Time),
   				DoubleToStr(f_Open,4),DoubleToStr(f_Low,4),
   				DoubleToStr(f_High,4),DoubleToStr(f_Close,4),
   				DoubleToStr(f_Volume,0));
		}
	}
//   FileClose(iFile);
   FileClose(lFile);
   for(i=0;i<6;i++)
   	FileClose(pFile[i]);*/
// end test display
   return(0);
}
//+------------------------------------------------------------------+